<!DOCTYPE html>
<html lang="en">
	<head>
		<title>three.js webgl loader</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
		<style>
			body {
				background: #caf8f1; 
				color:#fff;
				padding:0;
				margin:0;
				overflow:hidden;
                font-family: "HelveticaNeue-Light", "Helvetica Neue Light", "Helvetica Neue", Helvetica, Arial, sans-serif; 			
            }
		</style>
	</head>

	<body>
		<script src="js/three.min.js"></script>
        <script src="js/CopyShader.js"></script>   		
   		<script src="js/EffectComposer.js"></script>
        <script src="js/RenderPass.js"></script>
        <script src="js/ShaderPass.js"></script>
        <script src="js/MaskPass.js"></script>
        <script src="js/HorizontalTiltShiftShader.js"></script>
        <script src="js/VerticalTiltShiftShader.js"></script>
		<script src="js/Detector.js"></script>
        <script src="js/tween.min.js"></script>

		<script>
            var renderer, scene, camera, world, target, light, aeroplane, hblur, vblur, composer, copypass, rot=0;
            var SCREEN_WIDTH = window.innerWidth;
			var SCREEN_HEIGHT = window.innerHeight;
			var SCALE = 0.75;
            
            function init(){
                if ( ! Detector.webgl ) Detector.addGetWebGLMessage();

                scene = new THREE.Scene();
                if(SCREEN_WIDTH > 1400){
                    scene.fog = new THREE.FogExp2( 0xf5f8ca, 0.0015 );
                }
                camera = new THREE.PerspectiveCamera( 45, window.innerWidth / window.innerHeight, 0.1, 1000 );

                renderer = new THREE.WebGLRenderer( {antialias:true} );
                renderer.setClearColor( 0xcaf8f1, 0);
                renderer.setSize( window.innerWidth, window.innerHeight );
                renderer.autoClear = false;
                renderer.shadowMapEnabled = true;
	            renderer.shadowMapSoft = true;
                
                var renderModel = new THREE.RenderPass(scene, camera);
                copyPass = new THREE.ShaderPass(THREE.CopyShader);
                composer = new THREE.EffectComposer(renderer);
                composer.addPass(renderModel);
                hblur = new THREE.ShaderPass(THREE.HorizontalTiltShiftShader);
                vblur = new THREE.ShaderPass(THREE.VerticalTiltShiftShader);
                var bluriness = 4;

                hblur.uniforms['h'].value = bluriness / window.innerWidth;
                vblur.uniforms['v'].value = bluriness / window.innerHeight;
                hblur.uniforms['r'].value = vblur.uniforms['r'].value = 0.5;

                composer.addPass(hblur);
                composer.addPass(vblur);
                composer.addPass(copyPass);
                copyPass.renderToScreen = true;
                
                document.body.appendChild( renderer.domElement );

                
                var loader = new THREE.ObjectLoader();
                loader.load( 'js/scene.js', function ( object ) {
                    object.traverse( function( node ) { 
                        if ( node instanceof THREE.Mesh ) { 
                            node.castShadow = true; 
                            node.receiveShadow = true;
                        } 
                    });
                    scene.add( object );
                    world = scene.getObjectByName( "planet", true );

                    aeroplane = scene.getObjectByName( "aero", true );                    
                    
                    light = scene.getObjectByName( "spot", true );
                    light.castShadow = true;
                    //light.shadowCameraVisible = true;
                    light.shadowCameraNear = 5;
                    light.shadowCameraFar = 700;
                    light.shadowCameraFov = 90;

                    light.shadowBias = 0.0005;
                    if(SCREEN_WIDTH > 1400){
                        light.shadowDarkness = .65;
                    }else{
                        light.shadowDarkness = .20;
                    }

                    light.shadowMapWidth = 2048;
                    light.shadowMapHeight = 2048;
                    light.shadowMapType = THREE.PCFSoftShadowMap;
                    console.log(object);
                    
                    
                    render();
                } );
                
                camera.position.set( 0, 280, 300 );
                
                
            }
            
            function render () {
                requestAnimationFrame(render);
                camera.lookAt(new THREE.Vector3( 0, 230, 0 ));
                composer.render(0.01);
                world.rotation.z+=0.003;
                TWEEN.update();
                var time = Date.now() * 0.0009;
	            aeroplane.position.y = 270 + (5.3 * Math.sin( 3*time ) );
            };
            init();
            function nextStep(){
                console.log('click');
                var takeoff = new TWEEN.Tween( aeroplane.position ).to( {
						y: 300 }, 2000 )
					.easing( TWEEN.Easing.Quadratic.InOut);
                var land = new TWEEN.Tween( aeroplane.position ).to( {
						y: 225 }, 2000 )
					.easing( TWEEN.Easing.Quadratic.InOut);
                
                takeoff.chain(land);
                land.chain();
                takeoff.start();

				new TWEEN.Tween( world.rotation ).to( {
						z: rot += Math.PI/2 }, 5000 )
					.easing( TWEEN.Easing.Quadratic.InOut).start();    
            }

		</script>

	</body>
</html>
